<!DOCTYPE html>
<html lang="" xml:lang="">
  <head>
    <title>Collection and Analysis of digital behavioral data</title>
    <meta charset="utf-8" />
    <meta name="author" content="Long Nguyen, Zaza Zindel" />
    <meta name="date" content="2023-06-29" />
    <script src="10_Session_files/header-attrs/header-attrs.js"></script>
    <script src="10_Session_files/xaringanExtra-progressBar/progress-bar.js"></script>
    <link href="10_Session_files/tile-view/tile-view.css" rel="stylesheet" />
    <script src="10_Session_files/tile-view/tile-view.js"></script>
    <link href="10_Session_files/panelset/panelset.css" rel="stylesheet" />
    <script src="10_Session_files/panelset/panelset.js"></script>
    <link href="10_Session_files/xaringanExtra-extra-styles/xaringanExtra-extra-styles.css" rel="stylesheet" />
    <link rel="stylesheet" href="xaringan-unibi.css" type="text/css" />
    <link rel="stylesheet" href="width.css" type="text/css" />
    <link rel="stylesheet" href="https://rsms.me/inter/inter.css" type="text/css" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@xz/fonts@1/serve/ibm-plex-mono.min.css" type="text/css" />
  </head>
  <body>
    <textarea id="source">
class: left, bottom, title-slide

.title[
# Collection and Analysis of digital behavioral data
]
.subtitle[
## Data Analysis III
]
.author[
### Long Nguyen, Zaza Zindel
]
.date[
### 29 June 2023
]

---




<div>
<style type="text/css">.xaringan-extra-logo {
width: 200px;
height: 128px;
z-index: 0;
background-image: url(faksoz.png);
background-size: contain;
background-repeat: no-repeat;
position: absolute;
top:1em;right:.5em;
}
</style>
<script>(function () {
  let tries = 0
  function addLogo () {
    if (typeof slideshow === 'undefined') {
      tries += 1
      if (tries < 10) {
        setTimeout(addLogo, 100)
      }
    } else {
      document.querySelectorAll('.remark-slide-content')
        .forEach(function (slide) {
          const logo = document.createElement('div')
          logo.classList = 'xaringan-extra-logo'
          logo.href = null
          slide.appendChild(logo)
        })
    }
  }
  document.addEventListener('DOMContentLoaded', addLogo)
})()</script>
</div><style>.xe__progress-bar__container {
  bottom:0;
  opacity: 1;
  position:absolute;
  right:0;
  left: 0;
}
.xe__progress-bar {
  height: 5px;
  background-color: #bfd02f;
  width: calc(var(--slide-current) / var(--slide-total) * 100%);
}
.remark-visible .xe__progress-bar {
  animation: xe__progress-bar__wipe 200ms forwards;
  animation-timing-function: cubic-bezier(.86,0,.07,1);
}
@keyframes xe__progress-bar__wipe {
  0% { width: calc(var(--slide-previous) / var(--slide-total) * 100%); }
  100% { width: calc(var(--slide-current) / var(--slide-total) * 100%); }
}</style>



## Outline

- Word embeddings
- Word2vec

---
## What is a word embedding?
.pull-left.w80[
&gt; *Word embedding* is the collective name for a set of language modeling and feature learning techniques in language modeling where words or phrases from the vocabulary are mapped to vectors of real numbers.

**Main characteristics**: 

-   Every word used in a language can be presented by a unique word embedding, i.e., a set of real numbers ( = a vector)
-   Word embeddings are multidimensional
-   For each word, the embedding captures the "meaning" of the word
-   Similar words end up with similar embedding values
]
.pull-right.w20[
&lt;img src="text.jpg" width="80%" style="display: block; margin: auto;" /&gt;
]
---
## Why do we use word embeddings?

-   It is easy for humans to understand the relationship between words but for computers, this task may not be simple.

-   Many Machine Learning algorithms and almost all Deep Learning Architectures are incapable of processing strings or plain text in their raw form. -&gt; They require numbers as input to perform any sort of job.

-   **Goal of word embedding algorithms**: Embed words with meaning based on their similarity or relationship to other words.

---
## Example: Word Embeddings

This is a word embedding for the word **king**


```r
[ 0.50451 , 0.68607 , -0.59517 , -0.022801, 0.60046 , -0.13498 , -0.08813 , 0.47377 , -0.61798 , -0.31012 , -0.076666, 1.493 , -0.034189, -0.98173 , 0.68229 , 0.81722 , -0.51874 , -0.31503 , -0.55809 , 0.66421 , 0.1961 , -0.13495 , -0.11476 , -0.30344 , 0.41177 , -2.223 , -1.0756 , -1.0783 , -0.34354 , 0.33505 , 1.9927 , -0.04234 , -0.64319 , 0.71125 , 0.49159 , 0.16754 , 0.34344 , -0.25663 , -0.8523 , 0.1661 , 0.40102 , 1.1685 , -1.0137 , -0.21585 , -0.15155 , 0.78321 , -0.91241 , -1.6106 , -0.64426 , -0.51042 ]
```

It is a list of 50 numbers. We can't tell much by looking at the values.

--

Let's color code the cells based on their values:

&lt;img src="king-colored-embedding.png" width="100%" style="display: block; margin: auto;" /&gt;
---
## Example: Word Embeddings

Let's contrast **king** against other words:

&lt;img src="king-man-woman-embedding.png" width="80%" style="display: block; margin: auto;" /&gt;
--

-   **man** and **woman** are much more similar to each other than either of them is to **king**

-   These vector representations capture quite a bit of information and associations of these words

---
## Example: Word Embeddings

Here's another list of examples:

&lt;img src="queen-woman-girl-embeddings.png" width="70%" style="display: block; margin: auto;" /&gt;

-   What do you see in this example?

---
## Language Modeling
.pull-left.w70[
Now, let's learn more about the training process of such word embeddings.

A classic example of an neural language processing (NLP) application is the next-word prediction feature of a smartphone keyboard.

A language model can take a list of words, and attempt to predict the word that follows them.
]
.pull-right.w30[
&lt;img src="swiftkey-keyboard.png" width="80%" style="display: block; margin: auto;" /&gt;
]

---
## Language Modeling

In practice, the model does not output only one word but a probability score for all words it knows (= *vocabulary*)

&lt;img src="language_model_blackbox_output_vector.png" width="80%" style="display: block; margin: auto;" /&gt;

The keyboard application then has to find the words with the highest scores, and present those to the user.

---
## Language Model Training

Language models have a huge advantage over most other machine learning models 
**= We are able to train them on running text.**

Words get their embeddings by us looking at which other words tend to appear next to. 
The mechanism of that is that:

1.    We get a lot of text data
2.    We have a window (e.g., three words) that we slide against all of that text
3.    The sliding window generates training samples for our model.

---
### Example: Language Model Training 

&gt; *Thou shalt not make a machine in the likeness of a human mind*

When we start, the window is on the first three words of the sentence:

&lt;img src="lm-sliding-window.png" width="80%" style="display: block; margin: auto;" /&gt;
---
### Example: Language Model Training 

We take the first two words to be features, and the third word to be a label:

&lt;img src="lm-sliding-window-2.png" width="80%" style="display: block; margin: auto;" /&gt;

-   We now have generated the first sample in the dataset we can later use to train a language model
---
### Example: Language Model Training 

We then slide our window to the next position and create a second sample:

&lt;img src="lm-sliding-window-3.png" width="80%" style="display: block; margin: auto;" /&gt;

-   Pretty soon we have a larger data set of which words tend to appear after different pairs of words.

---
## Word2vec

&gt; *Word2vec* is one of the most popular predication based algorithm, for generating word embeddings.

The application uses a shallow neural network to mimic the human brain and develop the related meaning of words as determined by word contexts in sentences.

Two different learning models were introduced that can be used as part of the Word2vec approach

1.    Continuous Bag-of-Words
2.    Continuous Skip-Gram Models

---
## Continuous Bag-of-Words

The centre word is predicted based on its surrounding words.

### Example
&lt;img src="continuous-bag-of-words-example.png" width="50%" style="display: block; margin: auto;" /&gt;

In this context, a series of context words must be given in order to try and calculate the missing centre word.

---
## Continuous Skip-Gram Models

Instead of guessing a word based on its context, skim-gram models try to guess neighboring words using the current word.

### Example
&lt;img src="skipgram-sliding-window-samples.png" width="50%" style="display: block; margin: auto;" /&gt;

---
## Continuous Skip-Gram Models

### Example
We then slide our window to the next position and generate our next four examples.

&lt;img src="skipgram-sliding-window-4.png" width="70%" style="display: block; margin: auto;" /&gt;

---
## Revisiting the training process
    </textarea>
<style data-target="print-only">@media screen {.remark-slide-container{display:block;}.remark-slide-scaler{box-shadow:none;}}</style>
<script src="https://remarkjs.com/downloads/remark-latest.min.js"></script>
<script>var slideshow = remark.create({
"highlightStyle": "github",
"highlightLines": true,
"ratio": "16:9",
"countIncrementalSlides": false
});
if (window.HTMLWidgets) slideshow.on('afterShowSlide', function (slide) {
  window.dispatchEvent(new Event('resize'));
});
(function(d) {
  var s = d.createElement("style"), r = d.querySelector(".remark-slide-scaler");
  if (!r) return;
  s.type = "text/css"; s.innerHTML = "@page {size: " + r.style.width + " " + r.style.height +"; }";
  d.head.appendChild(s);
})(document);

(function(d) {
  var el = d.getElementsByClassName("remark-slides-area");
  if (!el) return;
  var slide, slides = slideshow.getSlides(), els = el[0].children;
  for (var i = 1; i < slides.length; i++) {
    slide = slides[i];
    if (slide.properties.continued === "true" || slide.properties.count === "false") {
      els[i - 1].className += ' has-continuation';
    }
  }
  var s = d.createElement("style");
  s.type = "text/css"; s.innerHTML = "@media print { .has-continuation { display: none; } }";
  d.head.appendChild(s);
})(document);
// delete the temporary CSS (for displaying all slides initially) when the user
// starts to view slides
(function() {
  var deleted = false;
  slideshow.on('beforeShowSlide', function(slide) {
    if (deleted) return;
    var sheets = document.styleSheets, node;
    for (var i = 0; i < sheets.length; i++) {
      node = sheets[i].ownerNode;
      if (node.dataset["target"] !== "print-only") continue;
      node.parentNode.removeChild(node);
    }
    deleted = true;
  });
})();
// add `data-at-shortcutkeys` attribute to <body> to resolve conflicts with JAWS
// screen reader (see PR #262)
(function(d) {
  let res = {};
  d.querySelectorAll('.remark-help-content table tr').forEach(tr => {
    const t = tr.querySelector('td:nth-child(2)').innerText;
    tr.querySelectorAll('td:first-child .key').forEach(key => {
      const k = key.innerText;
      if (/^[a-z]$/.test(k)) res[k] = t;  // must be a single letter (key)
    });
  });
  d.body.setAttribute('data-at-shortcutkeys', JSON.stringify(res));
})(document);
(function() {
  "use strict"
  // Replace <script> tags in slides area to make them executable
  var scripts = document.querySelectorAll(
    '.remark-slides-area .remark-slide-container script'
  );
  if (!scripts.length) return;
  for (var i = 0; i < scripts.length; i++) {
    var s = document.createElement('script');
    var code = document.createTextNode(scripts[i].textContent);
    s.appendChild(code);
    var scriptAttrs = scripts[i].attributes;
    for (var j = 0; j < scriptAttrs.length; j++) {
      s.setAttribute(scriptAttrs[j].name, scriptAttrs[j].value);
    }
    scripts[i].parentElement.replaceChild(s, scripts[i]);
  }
})();
(function() {
  var links = document.getElementsByTagName('a');
  for (var i = 0; i < links.length; i++) {
    if (/^(https?:)?\/\//.test(links[i].getAttribute('href'))) {
      links[i].target = '_blank';
    }
  }
})();
// adds .remark-code-has-line-highlighted class to <pre> parent elements
// of code chunks containing highlighted lines with class .remark-code-line-highlighted
(function(d) {
  const hlines = d.querySelectorAll('.remark-code-line-highlighted');
  const preParents = [];
  const findPreParent = function(line, p = 0) {
    if (p > 1) return null; // traverse up no further than grandparent
    const el = line.parentElement;
    return el.tagName === "PRE" ? el : findPreParent(el, ++p);
  };

  for (let line of hlines) {
    let pre = findPreParent(line);
    if (pre && !preParents.includes(pre)) preParents.push(pre);
  }
  preParents.forEach(p => p.classList.add("remark-code-has-line-highlighted"));
})(document);</script>

<script>
slideshow._releaseMath = function(el) {
  var i, text, code, codes = el.getElementsByTagName('code');
  for (i = 0; i < codes.length;) {
    code = codes[i];
    if (code.parentNode.tagName !== 'PRE' && code.childElementCount === 0) {
      text = code.textContent;
      if (/^\\\((.|\s)+\\\)$/.test(text) || /^\\\[(.|\s)+\\\]$/.test(text) ||
          /^\$\$(.|\s)+\$\$$/.test(text) ||
          /^\\begin\{([^}]+)\}(.|\s)+\\end\{[^}]+\}$/.test(text)) {
        code.outerHTML = code.innerHTML;  // remove <code></code>
        continue;
      }
    }
    i++;
  }
};
slideshow._releaseMath(document);
</script>
<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
(function () {
  var script = document.createElement('script');
  script.type = 'text/javascript';
  script.src  = 'https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-MML-AM_CHTML';
  if (location.protocol !== 'file:' && /^https?:/.test(script.src))
    script.src  = script.src.replace(/^https?:/, '');
  document.getElementsByTagName('head')[0].appendChild(script);
})();
</script>
  </body>
</html>
